/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.152 Revision 1.407
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.152 2005/02/18 18:04:42 azarah Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.407 2012/10/11 16:50:53 mgorny Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12inherit multilib 5# @ECLASS: eutils.eclass
13ECLASS=eutils 6# @MAINTAINER:
14INHERITED="$INHERITED $ECLASS" 7# base-system@gentoo.org
15 8# @BLURB: many extra (but common) functions that are used in ebuilds
16DEPEND="!bootstrap? ( sys-devel/patch )" 9# @DESCRIPTION:
17 10# The eutils eclass contains a suite of functions that complement
18DESCRIPTION="Based on the ${ECLASS} eclass" 11# the ones that ebuild.sh already contain. The idea is that the functions
19 12# are not required in all ebuilds but enough utilize them to have a common
20# ecpu_check 13# home rather than having multiple ebuilds implementing the same thing.
21# Usage:
22# 14#
23# ecpu_check array_of_cpu_flags 15# Due to the nature of this eclass, some functions may have maintainers
24# 16# different from the overall eclass!
25# array_of_cpu_flags - An array of cpu flags to check against USE flags
26#
27# Checks user USE related cpu flags against /proc/cpuinfo. If user enables a
28# cpu flag that is not supported in their processor flags, it will warn the
29# user if CROSSCOMPILE is not set to 1 ( because cross compile users are
30# obviously using different cpu flags than their own cpu ). Examples:
31#
32# CPU_FLAGS=(mmx mmx2 sse sse2)
33# ecpu_check CPU_FLAGS
34# Chris White <chriswhite@gentoo.org> (03 Feb 2005)
35 17
36ecpu_check() { 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
37 # Think about changing below to: if [ "${CROSSCOMPILE}" -ne 1 -a -e "/proc/cpuinfo" ] 19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
38 # and dropping the else if you do not plan on adding anything to that
39 # empty block ....
40 # PS: also try to add some quoting, and consider rather using ${foo} than $foo ...
41 if [ "${CROSSCOMPILE}" != "1" -a -e "/proc/cpuinfo" ]
42 then
43 CPU_FLAGS=${1}
44 USER_CPU=`grep "flags" /proc/cpuinfo`
45 20
46 for flags in `seq 1 ${#CPU_FLAGS[@]}` 21inherit multilib toolchain-funcs user
47 do
48 if has ${CPU_FLAGS[${flags} - 1]} ${USER_CPU} && ! has ${CPU_FLAGS[${flags} - 1]} ${USE}
49 then
50 ewarn "Your system is ${CPU_FLAGS[${flags} - 1]} capable but you don't have it enabled!"
51 ewarn "You might be cross compiling (in this case set CROSSCOMPILE to 1 to disable this warning."
52 fi
53 22
54 if ! has ${CPU_FLAGS[${flags} - 1]} ${USER_CPU} && has ${CPU_FLAGS[${flags} -1]} ${USE} 23if has "${EAPI:-0}" 0 1 2; then
55 then
56 ewarn "You have ${CPU_FLAGS[${flags} - 1]} support enabled but your processor doesn't"
57 ewarn "Seem to support it! You might be cross compiling or do not have /proc filesystem"
58 ewarn "enabled. If either is the case, set CROSSCOMPILE to 1 to disable this warning."
59 fi
60 done
61 fi
62}
63 24
64# Wait for the supplied number of seconds. If no argument is supplied, defaults 25# @FUNCTION: epause
65# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26# @USAGE: [seconds]
66# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @DESCRIPTION:
67# must be an integer greater than zero. 28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
68# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
69epause() { 32epause() {
70 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
71 sleep ${1:-5}
72 fi
73} 34}
74 35
75# Beep the specified number of times (defaults to five). If our output 36# @FUNCTION: ebeep
76# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 37# @USAGE: [number of beeps]
77# don't beep. 38# @DESCRIPTION:
78# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
79ebeep() { 43ebeep() {
80 local n 44 local n
81 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
82 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
83 echo -ne "\a" 47 echo -ne "\a"
84 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
85 echo -ne "\a" 49 echo -ne "\a"
86 sleep 1 50 sleep 1
87 done 51 done
88 fi 52 fi
89} 53}
90 54
91# This function generate linker scripts in /usr/lib for dynamic 55else
92# libs in /lib. This is to fix linking problems when you have
93# the .so in /lib, and the .a in /usr/lib. What happens is that
94# in some cases when linking dynamic, the .a in /usr/lib is used
95# instead of the .so in /lib due to gcc/libtool tweaking ld's
96# library search path. This cause many builds to fail.
97# See bug #4411 for more info.
98#
99# To use, simply call:
100#
101# gen_usr_ldscript libfoo.so
102#
103# Note that you should in general use the unversioned name of
104# the library, as ldconfig should usually update it correctly
105# to point to the latest version of the library present.
106#
107# <azarah@gentoo.org> (26 Oct 2002)
108#
109gen_usr_ldscript() {
110 local libdir="$(get_libdir)"
111 # Just make sure it exists
112 dodir /usr/${libdir}
113 56
114 cat > "${D}/usr/${libdir}/${1}" << END_LDSCRIPT 57ebeep() {
115/* GNU ld script 58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
116 Because Gentoo have critical dynamic libraries
117 in /lib, and the static versions in /usr/lib, we
118 need to have a "fake" dynamic lib in /usr/lib,
119 otherwise we run into linking problems.
120 See bug #4411 on http://bugs.gentoo.org/ for
121 more info. */
122GROUP ( /${libdir}/${1} )
123END_LDSCRIPT
124 fperms a+x "/usr/${libdir}/${1}"
125} 59}
126 60
127# Simple function to draw a line consisting of '=' the same length as $* 61epause() {
128# 62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
129# <azarah@gentoo.org> (11 Nov 2002) 63}
130#
131draw_line() {
132 local i=0
133 local str_length=""
134 64
135 # Handle calls that do not have args, or wc not being installed ... 65fi
136 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ] 66
137 then 67# @FUNCTION: eqawarn
138 echo "===============================================================" 68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: eshopts_push
150# @USAGE: [options to `set` or `shopt`]
151# @DESCRIPTION:
152# Often times code will want to enable a shell option to change code behavior.
153# Since changing shell options can easily break other pieces of code (which
154# assume the default state), eshopts_push is used to (1) push the current shell
155# options onto a stack and (2) pass the specified arguments to set.
156#
157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
159#
160# A common example is to disable shell globbing so that special meaning/care
161# may be used with variables/arguments to custom functions. That would be:
162# @CODE
163# eshopts_push -s noglob
164# for x in ${foo} ; do
165# if ...some check... ; then
166# eshopts_pop
139 return 0 167# return 0
140 fi 168# fi
141
142 # Get the length of $*
143 str_length="$(echo -n "$*" | wc -m)"
144
145 while [ "$i" -lt "${str_length}" ]
146 do
147 echo -n "="
148
149 i=$((i + 1))
150 done 169# done
151 170# eshopts_pop
152 echo 171# @CODE
153 172eshopts_push() {
154 return 0 173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
155} 182}
156 183
157# Default directory where patches are located 184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
158EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
159# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
160EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
161# Default options for patch 229# @VARIABLE: EPATCH_OPTS
162# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
163EPATCH_OPTS="-g0" 234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
242# --no-backup-if-mismatch - do not leave .orig files behind
243# -E - automatically remove empty files
244# @CODE
245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
164# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
165# and not the full path .. 249# and not the full path. Globs accepted.
166EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
167# Change the printed message for a single patch. 253# Change the printed message for a single patch.
168EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
169# Force applying bulk patches even if not following the style: 255# @VARIABLE: EPATCH_MULTI_MSG
170# 256# @DESCRIPTION:
171# ??_${ARCH}_foo.${EPATCH_SUFFIX} 257# Change the printed message for multiple patches.
172# 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
259# @VARIABLE: EPATCH_FORCE
260# @DESCRIPTION:
261# Only require patches to match EPATCH_SUFFIX rather than the extended
262# arch naming style.
173EPATCH_FORCE="no" 263EPATCH_FORCE="no"
174 264
175# This function is for bulk patching, or in theory for just one 265# @FUNCTION: epatch
176# or two patches. 266# @USAGE: [options] [patches] [dirs of patches]
267# @DESCRIPTION:
268# epatch is designed to greatly simplify the application of patches. It can
269# process patch files directly, or directories of patches. The patches may be
270# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
271# the -p option as epatch will automatically attempt -p0 to -p5 until things
272# apply successfully.
177# 273#
178# It should work with .bz2, .gz, .zip and plain text patches. 274# If you do not specify any patches/dirs, then epatch will default to the
179# Currently all patches should be the same format. 275# directory specified by EPATCH_SOURCE.
180# 276#
181# You do not have to specify '-p' option to patch, as it will 277# Any options specified that start with a dash will be passed down to patch
182# try with -p0 to -p5 until it succeed, or fail at -p5. 278# for this specific invocation. As soon as an arg w/out a dash is found, then
279# arg processing stops.
183# 280#
184# Above EPATCH_* variables can be used to control various defaults, 281# When processing directories, epatch will apply all patches that match:
185# bug they should be left as is to ensure an ebuild can rely on 282# @CODE
186# them for. 283# if ${EPATCH_FORCE} != "yes"
187#
188# Patches are applied in current directory.
189#
190# Bulk Patches should preferibly have the form of:
191#
192# ??_${ARCH}_foo.${EPATCH_SUFFIX} 284# ??_${ARCH}_foo.${EPATCH_SUFFIX}
285# else
286# *.${EPATCH_SUFFIX}
287# @CODE
288# The leading ?? are typically numbers used to force consistent patch ordering.
289# The arch field is used to apply patches only for the host architecture with
290# the special value of "all" means apply for everyone. Note that using values
291# other than "all" is highly discouraged -- you should apply patches all the
292# time and let architecture details be detected at configure/compile time.
193# 293#
194# For example: 294# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
295# for patches to apply.
195# 296#
196# 01_all_misc-fix.patch.bz2 297# Refer to the other EPATCH_xxx variables for more customization of behavior.
197# 02_sparc_another-fix.patch.bz2
198#
199# This ensures that there are a set order, and you can have ARCH
200# specific patches.
201#
202# If you however give an argument to epatch(), it will treat it as a
203# single patch that need to be applied if its a file. If on the other
204# hand its a directory, it will set EPATCH_SOURCE to this.
205#
206# <azarah@gentoo.org> (10 Nov 2002)
207#
208epatch() { 298epatch() {
209 local PIPE_CMD="" 299 _epatch_draw_line() {
210 local STDERR_TARGET="${T}/$$.out" 300 # create a line of same length as input string
211 local PATCH_TARGET="${T}/$$.patch" 301 [[ -z $1 ]] && set "$(printf "%65s" '')"
212 local PATCH_SUFFIX="" 302 echo "${1//?/=}"
213 local SINGLE_PATCH="no" 303 }
214 local x=""
215 304
216 if [ "$#" -gt 1 ] 305 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
217 then 306
307 # First process options. We localize the EPATCH_OPTS setting
308 # from above so that we can pass it on in the loop below with
309 # any additional values the user has specified.
310 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
311 while [[ $# -gt 0 ]] ; do
312 case $1 in
313 -*) EPATCH_OPTS+=( "$1" ) ;;
314 *) break ;;
315 esac
316 shift
317 done
318
319 # Let the rest of the code process one user arg at a time --
320 # each arg may expand into multiple patches, and each arg may
321 # need to start off with the default global EPATCH_xxx values
322 if [[ $# -gt 1 ]] ; then
218 local m="" 323 local m
219 einfo "${#} patches to apply ..."
220 for m in "$@" ; do 324 for m in "$@" ; do
221 epatch "${m}" 325 epatch "${m}"
222 done 326 done
223 return 0 327 return 0
224 fi 328 fi
225 329
226 if [ -n "$1" -a -f "$1" ] 330 local SINGLE_PATCH="no"
227 then 331 # no args means process ${EPATCH_SOURCE}
332 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
333
334 if [[ -f $1 ]] ; then
228 SINGLE_PATCH="yes" 335 SINGLE_PATCH="yes"
229 336 set -- "$1"
230 local EPATCH_SOURCE="$1" 337 # Use the suffix from the single patch (localize it); the code
338 # below will find the suffix for us
231 local EPATCH_SUFFIX="${1##*\.}" 339 local EPATCH_SUFFIX=$1
232 340
233 elif [ -n "$1" -a -d "$1" ] 341 elif [[ -d $1 ]] ; then
234 then 342 # Some people like to make dirs of patches w/out suffixes (vim)
235 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 343 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
236 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 344
345 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
346 # Re-use EPATCH_SOURCE as a search dir
347 epatch "${EPATCH_SOURCE}/$1"
348 return $?
349
350 else
351 # sanity check ... if it isn't a dir or file, wtf man ?
352 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
353 echo
354 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
355 eerror
356 eerror " ${EPATCH_SOURCE}"
357 eerror " ( ${EPATCH_SOURCE##*/} )"
358 echo
359 die "Cannot find \$EPATCH_SOURCE!"
360 fi
361
362 # Now that we know we're actually going to apply something, merge
363 # all of the patch options back in to a single variable for below.
364 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
365
366 local PIPE_CMD
367 case ${EPATCH_SUFFIX##*\.} in
368 xz) PIPE_CMD="xz -dc" ;;
369 lzma) PIPE_CMD="lzma -dc" ;;
370 bz2) PIPE_CMD="bzip2 -dc" ;;
371 gz|Z|z) PIPE_CMD="gzip -dc" ;;
372 ZIP|zip) PIPE_CMD="unzip -p" ;;
373 *) ;;
374 esac
375
376 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
377
378 local x
379 for x in "$@" ; do
380 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
381 # didn't match anything, ignore continue on
382 [[ ! -f ${x} ]] && continue
383
384 local patchname=${x##*/}
385
386 # Apply single patches, or forced sets of patches, or
387 # patches with ARCH dependant names.
388 # ???_arch_foo.patch
389 # Else, skip this input altogether
390 local a=${patchname#*_} # strip the ???_
391 a=${a%%_*} # strip the _foo.patch
392 if ! [[ ${SINGLE_PATCH} == "yes" || \
393 ${EPATCH_FORCE} == "yes" || \
394 ${a} == all || \
395 ${a} == ${ARCH} ]]
237 then 396 then
238 local EPATCH_SOURCE="$1/*" 397 continue
398 fi
399
400 # Let people filter things dynamically
401 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
402 # let people use globs in the exclude
403 eshopts_push -o noglob
404
405 local ex
406 for ex in ${EPATCH_EXCLUDE} ; do
407 if [[ ${patchname} == ${ex} ]] ; then
408 eshopts_pop
409 continue 2
410 fi
411 done
412
413 eshopts_pop
414 fi
415
416 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
417 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
418 einfo "${EPATCH_SINGLE_MSG}"
419 else
420 einfo "Applying ${patchname} ..."
421 fi
239 else 422 else
240 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 423 einfo " ${patchname} ..."
424 fi
425
426 # most of the time, there will only be one run per unique name,
427 # but if there are more, make sure we get unique log filenames
428 local STDERR_TARGET="${T}/${patchname}.out"
429 if [[ -e ${STDERR_TARGET} ]] ; then
430 STDERR_TARGET="${T}/${patchname}-$$.out"
431 fi
432
433 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
434
435 # Decompress the patch if need be
436 local count=0
437 local PATCH_TARGET
438 if [[ -n ${PIPE_CMD} ]] ; then
439 PATCH_TARGET="${T}/$$.patch"
440 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
441
442 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
443 echo
444 eerror "Could not extract patch!"
445 #die "Could not extract patch!"
446 count=5
447 break
241 fi 448 fi
449 else
450 PATCH_TARGET=${x}
451 fi
452
453 # Check for absolute paths in patches. If sandbox is disabled,
454 # people could (accidently) patch files in the root filesystem.
455 # Or trigger other unpleasantries #237667. So disallow -p0 on
456 # such patches.
457 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
458 if [[ -n ${abs_paths} ]] ; then
459 count=1
460 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
461 fi
462 # Similar reason, but with relative paths.
463 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
464 if [[ -n ${rel_paths} ]] ; then
465 eqawarn "QA Notice: Your patch uses relative paths '../'."
466 eqawarn " In the future this will cause a failure."
467 eqawarn "${rel_paths}"
468 fi
469
470 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
471 local patch_cmd
472 while [[ ${count} -lt 5 ]] ; do
473 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
474
475 # Generate some useful debug info ...
476 (
477 _epatch_draw_line "***** ${patchname} *****"
478 echo
479 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
480 echo
481 _epatch_draw_line "***** ${patchname} *****"
482 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
483 ret=$?
484 echo
485 echo "patch program exited with status ${ret}"
486 exit ${ret}
487 ) >> "${STDERR_TARGET}"
488
489 if [ $? -eq 0 ] ; then
490 (
491 _epatch_draw_line "***** ${patchname} *****"
492 echo
493 echo "ACTUALLY APPLYING ${patchname} ..."
494 echo
495 _epatch_draw_line "***** ${patchname} *****"
496 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
497 ret=$?
498 echo
499 echo "patch program exited with status ${ret}"
500 exit ${ret}
501 ) >> "${STDERR_TARGET}"
502
503 if [ $? -ne 0 ] ; then
504 echo
505 eerror "A dry-run of patch command succeeded, but actually"
506 eerror "applying the patch failed!"
507 #die "Real world sux compared to the dreamworld!"
508 count=5
509 fi
510 break
511 fi
512
513 : $(( count++ ))
514 done
515
516 # if we had to decompress the patch, delete the temp one
517 if [[ -n ${PIPE_CMD} ]] ; then
518 rm -f "${PATCH_TARGET}"
519 fi
520
521 if [[ ${count} -ge 5 ]] ; then
522 echo
523 eerror "Failed Patch: ${patchname} !"
524 eerror " ( ${PATCH_TARGET} )"
525 eerror
526 eerror "Include in your bugreport the contents of:"
527 eerror
528 eerror " ${STDERR_TARGET}"
529 echo
530 die "Failed Patch: ${patchname}!"
531 fi
532
533 # if everything worked, delete the full debug patch log
534 rm -f "${STDERR_TARGET}"
535
536 # then log away the exact stuff for people to review later
537 cat <<-EOF >> "${T}/epatch.log"
538 PATCH: ${x}
539 CMD: ${patch_cmd}
540 PWD: ${PWD}
541
542 EOF
543 eend 0
544 done
545
546 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
547 : # everything worked
548}
549
550# @FUNCTION: epatch_user
551# @USAGE:
552# @DESCRIPTION:
553# Applies user-provided patches to the source tree. The patches are
554# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
555# of these three directories to exist will be the one to use, ignoring
556# any more general directories which might exist as well. They must end
557# in ".patch" to be applied.
558#
559# User patches are intended for quick testing of patches without ebuild
560# modifications, as well as for permanent customizations a user might
561# desire. Obviously, there can be no official support for arbitrarily
562# patched ebuilds. So whenever a build log in a bug report mentions that
563# user patches were applied, the user should be asked to reproduce the
564# problem without these.
565#
566# Not all ebuilds do call this function, so placing patches in the
567# stated directory might or might not work, depending on the package and
568# the eclasses it inherits and uses. It is safe to call the function
569# repeatedly, so it is always possible to add a call at the ebuild
570# level. The first call is the time when the patches will be
571# applied.
572#
573# Ideally, this function should be called after gentoo-specific patches
574# have been applied, so that their code can be modified as well, but
575# before calls to e.g. eautoreconf, as the user patches might affect
576# autotool input files as well.
577epatch_user() {
578 [[ $# -ne 0 ]] && die "epatch_user takes no options"
579
580 # Allow multiple calls to this function; ignore all but the first
581 local applied="${T}/epatch_user.log"
582 [[ -e ${applied} ]] && return 2
583
584 # don't clobber any EPATCH vars that the parent might want
585 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
586 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
587 EPATCH_SOURCE=${base}/${CTARGET}/${check}
588 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
589 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
590 if [[ -d ${EPATCH_SOURCE} ]] ; then
591 EPATCH_SOURCE=${EPATCH_SOURCE} \
592 EPATCH_SUFFIX="patch" \
593 EPATCH_FORCE="yes" \
594 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
595 epatch
596 echo "${EPATCH_SOURCE}" > "${applied}"
597 return 0
598 fi
599 done
600 echo "none" > "${applied}"
601 return 1
602}
603
604# @FUNCTION: emktemp
605# @USAGE: [temp dir]
606# @DESCRIPTION:
607# Cheap replacement for when debianutils (and thus mktemp)
608# does not exist on the users system.
609emktemp() {
610 local exe="touch"
611 [[ $1 == -d ]] && exe="mkdir" && shift
612 local topdir=$1
613
614 if [[ -z ${topdir} ]] ; then
615 [[ -z ${T} ]] \
616 && topdir="/tmp" \
617 || topdir=${T}
618 fi
619
620 if ! type -P mktemp > /dev/null ; then
621 # system lacks `mktemp` so we have to fake it
622 local tmp=/
623 while [[ -e ${tmp} ]] ; do
624 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
625 done
626 ${exe} "${tmp}" || ${exe} -p "${tmp}"
627 echo "${tmp}"
242 else 628 else
243 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 629 # the args here will give slightly wierd names on BSD,
244 then 630 # but should produce a usable file on all userlands
245 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 631 if [[ ${exe} == "touch" ]] ; then
246 then 632 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
247 EPATCH_SOURCE="$1" 633 else
634 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
635 fi
636 fi
637}
638
639# @FUNCTION: edos2unix
640# @USAGE: <file> [more files ...]
641# @DESCRIPTION:
642# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
643# to remove all of these text utilities from DEPEND variables because this
644# is a script based solution. Just give it a list of files to convert and
645# they will all be changed from the DOS CRLF format to the UNIX LF format.
646edos2unix() {
647 [[ $# -eq 0 ]] && return 0
648 sed -i 's/\r$//' -- "$@" || die
649}
650
651# @FUNCTION: make_desktop_entry
652# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
653# @DESCRIPTION:
654# Make a .desktop file.
655#
656# @CODE
657# binary: what command does the app run with ?
658# name: the name that will show up in the menu
659# icon: the icon to use in the menu entry
660# this can be relative (to /usr/share/pixmaps) or
661# a full path to an icon
662# type: what kind of application is this?
663# for categories:
664# http://standards.freedesktop.org/menu-spec/latest/apa.html
665# if unset, function tries to guess from package's category
666# fields: extra fields to append to the desktop file; a printf string
667# @CODE
668make_desktop_entry() {
669 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
670
671 local exec=${1}
672 local name=${2:-${PN}}
673 local icon=${3:-${PN}}
674 local type=${4}
675 local fields=${5}
676
677 if [[ -z ${type} ]] ; then
678 local catmaj=${CATEGORY%%-*}
679 local catmin=${CATEGORY##*-}
680 case ${catmaj} in
681 app)
682 case ${catmin} in
683 accessibility) type="Utility;Accessibility";;
684 admin) type=System;;
685 antivirus) type=System;;
686 arch) type="Utility;Archiving";;
687 backup) type="Utility;Archiving";;
688 cdr) type="AudioVideo;DiscBurning";;
689 dicts) type="Office;Dictionary";;
690 doc) type=Documentation;;
691 editors) type="Utility;TextEditor";;
692 emacs) type="Development;TextEditor";;
693 emulation) type="System;Emulator";;
694 laptop) type="Settings;HardwareSettings";;
695 office) type=Office;;
696 pda) type="Office;PDA";;
697 vim) type="Development;TextEditor";;
698 xemacs) type="Development;TextEditor";;
699 esac
700 ;;
701
702 dev)
703 type="Development"
704 ;;
705
706 games)
707 case ${catmin} in
708 action|fps) type=ActionGame;;
709 arcade) type=ArcadeGame;;
710 board) type=BoardGame;;
711 emulation) type=Emulator;;
712 kids) type=KidsGame;;
713 puzzle) type=LogicGame;;
714 roguelike) type=RolePlaying;;
715 rpg) type=RolePlaying;;
716 simulation) type=Simulation;;
717 sports) type=SportsGame;;
718 strategy) type=StrategyGame;;
719 esac
720 type="Game;${type}"
721 ;;
722
723 gnome)
724 type="Gnome;GTK"
725 ;;
726
727 kde)
728 type="KDE;Qt"
729 ;;
730
731 mail)
732 type="Network;Email"
733 ;;
734
735 media)
736 case ${catmin} in
737 gfx)
738 type=Graphics
739 ;;
740 *)
741 case ${catmin} in
742 radio) type=Tuner;;
743 sound) type=Audio;;
744 tv) type=TV;;
745 video) type=Video;;
746 esac
747 type="AudioVideo;${type}"
748 ;;
749 esac
750 ;;
751
752 net)
753 case ${catmin} in
754 dialup) type=Dialup;;
755 ftp) type=FileTransfer;;
756 im) type=InstantMessaging;;
757 irc) type=IRCClient;;
758 mail) type=Email;;
759 news) type=News;;
760 nntp) type=News;;
761 p2p) type=FileTransfer;;
762 voip) type=Telephony;;
763 esac
764 type="Network;${type}"
765 ;;
766
767 sci)
768 case ${catmin} in
769 astro*) type=Astronomy;;
770 bio*) type=Biology;;
771 calc*) type=Calculator;;
772 chem*) type=Chemistry;;
773 elec*) type=Electronics;;
774 geo*) type=Geology;;
775 math*) type=Math;;
776 physics) type=Physics;;
777 visual*) type=DataVisualization;;
778 esac
779 type="Education;Science;${type}"
780 ;;
781
782 sys)
783 type="System"
784 ;;
785
786 www)
787 case ${catmin} in
788 client) type=WebBrowser;;
789 esac
790 type="Network;${type}"
791 ;;
792
793 *)
794 type=
795 ;;
796 esac
797 fi
798 if [ "${SLOT}" == "0" ] ; then
799 local desktop_name="${PN}"
800 else
801 local desktop_name="${PN}-${SLOT}"
802 fi
803 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
804 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
805
806 # Don't append another ";" when a valid category value is provided.
807 type=${type%;}${type:+;}
808
809 eshopts_push -s extglob
810 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
811 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
812 ewarn "allowed in .desktop files if the value is not an absolute path."
813 icon=${icon%.@(xpm|png|svg)}
814 fi
815 eshopts_pop
816
817 cat <<-EOF > "${desktop}"
818 [Desktop Entry]
819 Name=${name}
820 Type=Application
821 Comment=${DESCRIPTION}
822 Exec=${exec}
823 TryExec=${exec%% *}
824 Icon=${icon}
825 Categories=${type}
826 EOF
827
828 if [[ ${fields:-=} != *=* ]] ; then
829 # 5th arg used to be value to Path=
830 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
831 fields="Path=${fields}"
832 fi
833 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
834
835 (
836 # wrap the env here so that the 'insinto' call
837 # doesn't corrupt the env of the caller
838 insinto /usr/share/applications
839 doins "${desktop}"
840 ) || die "installing desktop file failed"
841}
842
843# @FUNCTION: validate_desktop_entries
844# @USAGE: [directories]
845# @MAINTAINER:
846# Carsten Lohrke <carlo@gentoo.org>
847# @DESCRIPTION:
848# Validate desktop entries using desktop-file-utils
849validate_desktop_entries() {
850 if [[ -x /usr/bin/desktop-file-validate ]] ; then
851 einfo "Checking desktop entry validity"
852 local directories=""
853 for d in /usr/share/applications $@ ; do
854 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
855 done
856 if [[ -n ${directories} ]] ; then
857 for FILE in $(find ${directories} -name "*\.desktop" \
858 -not -path '*.hidden*' | sort -u 2>/dev/null)
859 do
860 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
861 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
862 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
863 done
864 fi
865 echo ""
866 else
867 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
868 fi
869}
870
871# @FUNCTION: make_session_desktop
872# @USAGE: <title> <command> [command args...]
873# @DESCRIPTION:
874# Make a GDM/KDM Session file. The title is the file to execute to start the
875# Window Manager. The command is the name of the Window Manager.
876#
877# You can set the name of the file via the ${wm} variable.
878make_session_desktop() {
879 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
880 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
881
882 local title=$1
883 local command=$2
884 local desktop=${T}/${wm:-${PN}}.desktop
885 shift 2
886
887 cat <<-EOF > "${desktop}"
888 [Desktop Entry]
889 Name=${title}
890 Comment=This session logs you into ${title}
891 Exec=${command} $*
892 TryExec=${command}
893 Type=XSession
894 EOF
895
896 (
897 # wrap the env here so that the 'insinto' call
898 # doesn't corrupt the env of the caller
899 insinto /usr/share/xsessions
900 doins "${desktop}"
901 )
902}
903
904# @FUNCTION: domenu
905# @USAGE: <menus>
906# @DESCRIPTION:
907# Install the list of .desktop menu files into the appropriate directory
908# (/usr/share/applications).
909domenu() {
910 (
911 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller
913 local i j ret=0
914 insinto /usr/share/applications
915 for i in "$@" ; do
916 if [[ -f ${i} ]] ; then
917 doins "${i}"
918 ((ret+=$?))
919 elif [[ -d ${i} ]] ; then
920 for j in "${i}"/*.desktop ; do
921 doins "${j}"
922 ((ret+=$?))
923 done
924 else
925 ((++ret))
926 fi
927 done
928 exit ${ret}
929 )
930}
931
932# @FUNCTION: newmenu
933# @USAGE: <menu> <newname>
934# @DESCRIPTION:
935# Like all other new* functions, install the specified menu as newname.
936newmenu() {
937 (
938 # wrap the env here so that the 'insinto' call
939 # doesn't corrupt the env of the caller
940 insinto /usr/share/applications
941 newins "$@"
942 )
943}
944
945# @FUNCTION: _iconins
946# @INTERNAL
947# @DESCRIPTION:
948# function for use in doicon and newicon
949_iconins() {
950 (
951 # wrap the env here so that the 'insinto' call
952 # doesn't corrupt the env of the caller
953 local funcname=$1; shift
954 local size dir
955 local context=apps
956 local theme=hicolor
957
958 while [[ $# -gt 0 ]] ; do
959 case $1 in
960 -s|--size)
961 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
962 size=${2%%x*}
963 else
964 size=${2}
248 fi 965 fi
249 966 case ${size} in
250 echo 967 16|22|24|32|36|48|64|72|96|128|192|256)
251 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 968 size=${size}x${size};;
252 eerror 969 scalable)
253 eerror " ${EPATCH_SOURCE}"
254 eerror " ( ${EPATCH_SOURCE##*/} )"
255 echo
256 die "Cannot find \$EPATCH_SOURCE!"
257 fi
258
259 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
260 fi
261
262 case ${EPATCH_SUFFIX##*\.} in
263 bz2)
264 PIPE_CMD="bzip2 -dc"
265 PATCH_SUFFIX="bz2"
266 ;; 970 ;;
267 gz|Z|z) 971 *)
268 PIPE_CMD="gzip -dc" 972 eerror "${size} is an unsupported icon size!"
269 PATCH_SUFFIX="gz" 973 exit 1;;
270 ;; 974 esac
271 ZIP|zip) 975 shift 2;;
272 PIPE_CMD="unzip -p" 976 -t|--theme)
273 PATCH_SUFFIX="zip" 977 theme=${2}
274 ;; 978 shift 2;;
979 -c|--context)
980 context=${2}
981 shift 2;;
275 *) 982 *)
276 PIPE_CMD="cat" 983 if [[ -z ${size} ]] ; then
277 PATCH_SUFFIX="patch" 984 insinto /usr/share/pixmaps
278 ;; 985 else
279 esac 986 insinto /usr/share/icons/${theme}/${size}/${context}
280
281 if [ "${SINGLE_PATCH}" = "no" ]
282 then
283 einfo "Applying various patches (bugfixes/updates) ..."
284 fi
285 for x in ${EPATCH_SOURCE}
286 do
287 # New ARCH dependant patch naming scheme ...
288 #
289 # ???_arch_foo.patch
290 #
291 if [ -f ${x} ] && \
292 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
293 [ "${EPATCH_FORCE}" = "yes" ])
294 then
295 local count=0
296 local popts="${EPATCH_OPTS}"
297 local patchname=${x##*/}
298
299 if [ -n "${EPATCH_EXCLUDE}" ]
300 then
301 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
302 then
303 continue
304 fi
305 fi 987 fi
306 988
307 if [ "${SINGLE_PATCH}" = "yes" ] 989 if [[ ${funcname} == doicon ]] ; then
308 then 990 if [[ -f $1 ]] ; then
309 if [ -n "${EPATCH_SINGLE_MSG}" ] 991 doins "${1}"
310 then 992 elif [[ -d $1 ]] ; then
311 einfo "${EPATCH_SINGLE_MSG}" 993 shopt -s nullglob
994 doins "${1}"/*.{png,svg}
995 shopt -u nullglob
312 else 996 else
313 einfo "Applying ${patchname} ..." 997 eerror "${1} is not a valid file/directory!"
998 exit 1
314 fi 999 fi
315 else 1000 else
316 einfo " ${patchname} ..." 1001 break
317 fi 1002 fi
318 1003 shift 1;;
319 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 1004 esac
320 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
321
322 # Allow for prefix to differ ... im lazy, so shoot me :/
323 while [ "${count}" -lt 5 ]
324 do
325 # Generate some useful debug info ...
326 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
327 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
328
329 if [ "${PATCH_SUFFIX}" != "patch" ]
330 then
331 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
332 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
333 else
334 PATCH_TARGET="${x}"
335 fi
336
337 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
338 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
339
340 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
341 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
342
343 if [ "${PATCH_SUFFIX}" != "patch" ]
344 then
345 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
346 then
347 echo
348 eerror "Could not extract patch!"
349 #die "Could not extract patch!"
350 count=5
351 break
352 fi
353 fi
354
355 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
356 then
357 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
358 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
359 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
360 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
361 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
362
363 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
364
365 if [ "$?" -ne 0 ]
366 then
367 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
368 echo
369 eerror "A dry-run of patch command succeeded, but actually"
370 eerror "applying the patch failed!"
371 #die "Real world sux compared to the dreamworld!"
372 count=5
373 fi
374
375 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
376
377 break
378 fi
379
380 count=$((count + 1))
381 done
382
383 if [ "${PATCH_SUFFIX}" != "patch" ]
384 then
385 rm -f ${PATCH_TARGET}
386 fi
387
388 if [ "${count}" -eq 5 ]
389 then
390 echo
391 eerror "Failed Patch: ${patchname}!"
392 eerror
393 eerror "Include in your bugreport the contents of:"
394 eerror
395 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
396 echo
397 die "Failed Patch: ${patchname}!"
398 fi
399
400 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
401
402 eend 0
403 fi
404 done 1005 done
405 if [ "${SINGLE_PATCH}" = "no" ] 1006 if [[ ${funcname} == newicon ]] ; then
406 then 1007 newins "$@"
407 einfo "Done with patching"
408 fi
409}
410
411# This function return true if we are using the NPTL pthreads
412# implementation.
413#
414# <azarah@gentoo.org> (06 March 2003)
415#
416have_NPTL() {
417 cat > ${T}/test-nptl.c <<-"END"
418 #define _XOPEN_SOURCE
419 #include <unistd.h>
420 #include <stdio.h>
421
422 int main()
423 {
424 char buf[255];
425 char *str = buf;
426
427 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
428 if (NULL != str) {
429 printf("%s\n", str);
430 if (NULL != strstr(str, "NPTL"))
431 return 0;
432 }
433
434 return 1;
435 }
436 END
437
438 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ..."
439 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
440 then
441 echo "yes"
442 einfon "Checking what PTHREADS implementation we have ..."
443 if ${T}/nptl
444 then
445 return 0
446 else
447 return 1
448 fi 1008 fi
449 else 1009 ) || die
450 echo "no"
451 fi
452
453 return 1
454} 1010}
455 1011
456# This function check how many cpu's are present, and then set 1012# @FUNCTION: doicon
457# -j in MAKEOPTS accordingly. 1013# @USAGE: [options] <icons>
1014# @DESCRIPTION:
1015# Install icon into the icon directory /usr/share/icons or into
1016# /usr/share/pixmaps if "--size" is not set.
1017# This is useful in conjunction with creating desktop/menu files.
458# 1018#
459# Thanks to nall <nall@gentoo.org> for this. 1019# @CODE
1020# options:
1021# -s, --size
1022# !!! must specify to install into /usr/share/icons/... !!!
1023# size of the icon, like 48 or 48x48
1024# supported icon sizes are:
1025# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1026# -c, --context
1027# defaults to "apps"
1028# -t, --theme
1029# defaults to "hicolor"
460# 1030#
461get_number_of_jobs() { 1031# icons: list of icons
462 local jobs=0
463
464 return 0
465
466 if [ ! -r /proc/cpuinfo ]
467 then
468 return 1
469 fi
470
471 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
472 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
473 then
474 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
475 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
476 ADMINPARAM="${ADMINPARAM/-j}"
477 fi
478
479 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
480
481 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
482 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
483 then
484 # these archs will always have "[Pp]rocessor"
485 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
486
487 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
488 then
489 # sparc always has "ncpus active"
490 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
491
492 elif [ "${ARCH}" = "alpha" ]
493 then
494 # alpha has "cpus active", but only when compiled with SMP
495 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
496 then
497 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
498 else
499 jobs=2
500 fi
501
502 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
503 then
504 # ppc has "processor", but only when compiled with SMP
505 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
506 then
507 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
508 else
509 jobs=2
510 fi
511 elif [ "${ARCH}" = "s390" ]
512 then
513 # s390 has "# processors : "
514 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
515 else
516 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
517 die "Unknown ARCH -- ${ARCH}!"
518 fi
519
520 # Make sure the number is valid ...
521 if [ "${jobs}" -lt 1 ]
522 then
523 jobs=1
524 fi
525
526 if [ -n "${ADMINPARAM}" ]
527 then
528 if [ "${jobs}" -gt "${ADMINPARAM}" ]
529 then
530 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge ..."
531 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
532 else
533 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge ..."
534 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
535 fi
536 fi
537}
538
539# Cheap replacement for when debianutils (and thus mktemp)
540# does not exist on the users system
541# vapier@gentoo.org
542# 1032#
543# Takes just 1 optional parameter (the directory to create tmpfile in) 1033# example 1: doicon foobar.png fuqbar.svg suckbar.png
544emktemp() { 1034# results in: insinto /usr/share/pixmaps
545 local exe="touch" 1035# doins foobar.png fuqbar.svg suckbar.png
546 [ "$1" == "-d" ] && exe="mkdir" && shift
547 local topdir="$1"
548
549 if [ -z "${topdir}" ]
550 then
551 [ -z "${T}" ] \
552 && topdir="/tmp" \
553 || topdir="${T}"
554 fi
555
556 if [ -z "$(type -p mktemp)" ]
557 then
558 local tmp=/
559 while [ -e "${tmp}" ] ; do
560 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}"
561 done
562 ${exe} "${tmp}"
563 echo "${tmp}"
564 else
565 [ "${exe}" == "touch" ] \
566 && exe="-p" \
567 || exe="-d"
568 mktemp ${exe} "${topdir}"
569 fi
570}
571
572# Small wrapper for getent (Linux), nidump (Mac OS X),
573# and pw (FreeBSD) used in enewuser()/enewgroup()
574# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
575# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
576# 1036#
577# egetent(database, key) 1037# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
578egetent() { 1038# results in: insinto /usr/share/icons/hicolor/48x48/apps
579 if useq ppc-macos ; then 1039# doins foobar.png fuqbar.png blobbar.png
580 case "$2" in 1040# @CODE
581 *[!0-9]*) # Non numeric
582 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
583 ;;
584 *) # Numeric
585 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
586 ;;
587 esac
588 elif useq x86-fbsd ; then
589 local action
590 if [ "$1" == "passwd" ]
591 then
592 action="user"
593 else
594 action="group"
595 fi
596 pw show "${action}" "$2" -q
597 else
598 which nscd >& /dev/null && nscd -i "$1"
599 getent "$1" "$2"
600 fi
601}
602
603# Simplify/standardize adding users to the system
604# vapier@gentoo.org
605#
606# enewuser(username, uid, shell, homedir, groups, extra options)
607#
608# Default values if you do not specify any:
609# username: REQUIRED !
610# uid: next available (see useradd(8))
611# note: pass -1 to get default behavior
612# shell: /bin/false
613# homedir: /dev/null
614# groups: none
615# extra: comment of 'added by portage for ${PN}'
616enewuser() {
617 # get the username
618 local euser="$1"; shift
619 if [ -z "${euser}" ]
620 then
621 eerror "No username specified !"
622 die "Cannot call enewuser without a username"
623 fi
624
625 # lets see if the username already exists
626 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ]
627 then
628 return 0
629 fi
630 einfo "Adding user '${euser}' to your system ..."
631
632 # options to pass to useradd
633 local opts=
634
635 # handle uid
636 local euid="$1"; shift
637 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
638 then
639 if [ "${euid}" -gt 0 ]
640 then
641 if [ ! -z "`egetent passwd ${euid}`" ]
642 then
643 euid="next"
644 fi
645 else
646 eerror "Userid given but is not greater than 0 !"
647 die "${euid} is not a valid UID"
648 fi
649 else
650 euid="next"
651 fi
652 if [ "${euid}" == "next" ]
653 then
654 local pwrange
655 if [ "${USERLAND}" == "BSD" ] ; then
656 pwrange="`jot 898 101`"
657 else
658 pwrange="`seq 101 999`"
659 fi
660 for euid in ${pwrange} ; do
661 [ -z "`egetent passwd ${euid}`" ] && break
662 done
663 fi
664 opts="${opts} -u ${euid}"
665 einfo " - Userid: ${euid}"
666
667 # handle shell
668 local eshell="$1"; shift
669 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ]
670 then
671 if [ ! -e "${eshell}" ]
672 then
673 eerror "A shell was specified but it does not exist !"
674 die "${eshell} does not exist"
675 fi
676 else
677 if [ "${USERLAND}" == "BSD" ]
678 then
679 eshell="/usr/bin/false"
680 else
681 eshell="/bin/false"
682 fi
683 fi
684 einfo " - Shell: ${eshell}"
685 opts="${opts} -s ${eshell}"
686
687 # handle homedir
688 local ehome="$1"; shift
689 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ]
690 then
691 ehome="/dev/null"
692 fi
693 einfo " - Home: ${ehome}"
694 opts="${opts} -d ${ehome}"
695
696 # handle groups
697 local egroups="$1"; shift
698 if [ ! -z "${egroups}" ]
699 then
700 local oldifs="${IFS}"
701 local defgroup="" exgroups=""
702
703 export IFS=","
704 for g in ${egroups}
705 do
706 export IFS="${oldifs}"
707 if [ -z "`egetent group \"${g}\"`" ]
708 then
709 eerror "You must add group ${g} to the system first"
710 die "${g} is not a valid GID"
711 fi
712 if [ -z "${defgroup}" ]
713 then
714 defgroup="${g}"
715 else
716 exgroups="${exgroups},${g}"
717 fi
718 export IFS=","
719 done
720 export IFS="${oldifs}"
721
722 opts="${opts} -g ${defgroup}"
723 if [ ! -z "${exgroups}" ]
724 then
725 opts="${opts} -G ${exgroups:1}"
726 fi
727 else
728 egroups="(none)"
729 fi
730 einfo " - Groups: ${egroups}"
731
732 # handle extra and add the user
733 local eextra="$@"
734 local oldsandbox="${SANDBOX_ON}"
735 export SANDBOX_ON="0"
736 if useq ppc-macos
737 then
738 ### Make the user
739 if [ -z "${eextra}" ]
740 then
741 dscl . create /users/${euser} uid ${euid}
742 dscl . create /users/${euser} shell ${eshell}
743 dscl . create /users/${euser} home ${ehome}
744 dscl . create /users/${euser} realname "added by portage for ${PN}"
745 ### Add the user to the groups specified
746 local oldifs="${IFS}"
747 export IFS=","
748 for g in ${egroups}
749 do
750 dscl . merge /groups/${g} users ${euser}
751 done
752 export IFS="${oldifs}"
753 else
754 einfo "Extra options are not supported on macos yet"
755 einfo "Please report the ebuild along with the info below"
756 einfo "eextra: ${eextra}"
757 die "Required function missing"
758 fi
759 elif use x86-fbsd ; then
760 if [ -z "${eextra}" ]
761 then
762 pw useradd ${euser} ${opts} \
763 -c "added by portage for ${PN}" \
764 die "enewuser failed"
765 else
766 einfo " - Extra: ${eextra}"
767 pw useradd ${euser} ${opts} \
768 -c ${eextra} || die "enewuser failed"
769 fi
770 else
771 if [ -z "${eextra}" ]
772 then
773 useradd ${opts} ${euser} \
774 -c "added by portage for ${PN}" \
775 || die "enewuser failed"
776 else
777 einfo " - Extra: ${eextra}"
778 useradd ${opts} ${euser} ${eextra} \
779 || die "enewuser failed"
780 fi
781 fi
782 export SANDBOX_ON="${oldsandbox}"
783
784 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
785 then
786 einfo " - Creating ${ehome} in ${D}"
787 dodir ${ehome}
788 fowners ${euser} ${ehome}
789 fperms 755 ${ehome}
790 fi
791}
792
793# Simplify/standardize adding groups to the system
794# vapier@gentoo.org
795#
796# enewgroup(group, gid)
797#
798# Default values if you do not specify any:
799# groupname: REQUIRED !
800# gid: next available (see groupadd(8))
801# extra: none
802enewgroup() {
803 # get the group
804 local egroup="$1"; shift
805 if [ -z "${egroup}" ]
806 then
807 eerror "No group specified !"
808 die "Cannot call enewgroup without a group"
809 fi
810
811 # see if group already exists
812 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
813 then
814 return 0
815 fi
816 einfo "Adding group '${egroup}' to your system ..."
817
818 # options to pass to useradd
819 local opts=
820
821 # handle gid
822 local egid="$1"; shift
823 if [ ! -z "${egid}" ]
824 then
825 if [ "${egid}" -gt 0 ]
826 then
827 if [ -z "`egetent group ${egid}`" ]
828 then
829 if useq ppc-macos ; then
830 opts="${opts} ${egid}"
831 else
832 opts="${opts} -g ${egid}"
833 fi
834 else
835 egid="next available; requested gid taken"
836 fi
837 else
838 eerror "Groupid given but is not greater than 0 !"
839 die "${egid} is not a valid GID"
840 fi
841 else
842 egid="next available"
843 fi
844 einfo " - Groupid: ${egid}"
845
846 # handle extra
847 local eextra="$@"
848 opts="${opts} ${eextra}"
849
850 # add the group
851 local oldsandbox="${SANDBOX_ON}"
852 export SANDBOX_ON="0"
853 if useq ppc-macos ; then
854 if [ ! -z "${eextra}" ];
855 then
856 einfo "Extra options are not supported on macos yet"
857 einfo "Please report the ebuild along with the info below"
858 einfo "eextra: ${eextra}"
859 die "Required function missing"
860 fi
861
862 # If we need the next available
863 case ${egid} in
864 *[!0-9]*) # Non numeric
865 for egid in `jot 898 101`; do
866 [ -z "`egetent group ${egid}`" ] && break
867 done
868 esac
869 dscl . create /groups/${egroup} gid ${egid}
870 dscl . create /groups/${egroup} passwd '*'
871 elif use x86-fbsd ; then
872 case ${egid} in
873 *[!0-9]*) # Non numeric
874 for egid in `jot 898 101`; do
875 [ -z "`egetent group ${egid}`" ] && break
876 done
877 esac
878 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
879 else
880 groupadd ${opts} ${egroup} || die "enewgroup failed"
881 fi
882 export SANDBOX_ON="${oldsandbox}"
883}
884
885# Simple script to replace 'dos2unix' binaries
886# vapier@gentoo.org
887#
888# edos2unix(file, <more files> ...)
889edos2unix() {
890 for f in "$@"
891 do
892 cp "${f}" ${T}/edos2unix
893 sed 's/\r$//' ${T}/edos2unix > "${f}"
894 done
895}
896
897
898##############################################################
899# START: Handle .desktop files and menu entries #
900# maybe this should be separated into a new eclass some time #
901# lanius@gentoo.org #
902##############################################################
903
904# Make a desktop file !
905# Great for making those icons in kde/gnome startmenu !
906# Amaze your friends ! Get the women ! Join today !
907#
908# make_desktop_entry(<binary>, [name], [icon], [type], [path])
909#
910# binary: what binary does the app run with ?
911# name: the name that will show up in the menu
912# icon: give your little like a pretty little icon ...
913# this can be relative (to /usr/share/pixmaps) or
914# a full path to an icon
915# type: what kind of application is this ? for categories:
916# http://www.freedesktop.org/standards/menu-spec/
917# path: if your app needs to startup in a specific dir
918make_desktop_entry() {
919 [ -z "$1" ] && eerror "make_desktop_entry: You must specify the executable" && return 1
920
921 local exec="${1}"
922 local name="${2:-${PN}}"
923 local icon="${3:-${PN}.png}"
924 local type="${4}"
925 local subdir="${6}"
926 local path="${5:-${GAMES_BINDIR}}"
927 if [ -z "${type}" ]
928 then
929 case ${CATEGORY} in
930 "app-emulation")
931 type=Emulator
932 subdir="Emulation"
933 ;;
934 "games-"*)
935 type=Game
936 subdir="Games"
937 ;;
938 "net-"*)
939 type=Network
940 subdir="${type}"
941 ;;
942 *)
943 type=
944 subdir=
945 ;;
946 esac
947 fi
948 local desktop="${T}/${exec}.desktop"
949
950echo "[Desktop Entry]
951Encoding=UTF-8
952Version=0.9.2
953Name=${name}
954Type=Application
955Comment=${DESCRIPTION}
956Exec=${exec}
957Path=${path}
958Icon=${icon}
959Categories=Application;${type};" > "${desktop}"
960
961 insinto /usr/share/applications
962 doins "${desktop}"
963
964 return 0
965}
966
967# Make a GDM/KDM Session file
968#
969# make_desktop_entry(<title>, <command>)
970# title: File to execute to start the Window Manager
971# command: Name of the Window Manager
972
973make_session_desktop() {
974
975 [ -z "$1" ] && eerror "make_session_desktop: You must specify the title" && return 1
976 [ -z "$2" ] && eerror "make_session_desktop: You must specify the command" && return 1
977
978 local title="${1}"
979 local command="${2}"
980 local desktop="${T}/${wm}.desktop"
981
982echo "[Desktop Entry]
983Encoding=UTF-8
984Name=${title}
985Comment=This session logs you into ${title}
986Exec=${command}
987TryExec=${command}
988Type=Application" > "${desktop}"
989
990 insinto /usr/share/xsessions
991 doins "${desktop}"
992
993 return 0
994}
995
996domenu() {
997 local i
998 local j
999 insinto /usr/share/applications
1000 for i in ${@}
1001 do
1002 if [ -f "${i}" ];
1003 then
1004 doins ${i}
1005 elif [ -d "${i}" ];
1006 then
1007 for j in ${i}/*.desktop
1008 do
1009 doins ${j}
1010 done
1011 fi
1012 done
1013}
1014
1015doicon() { 1041doicon() {
1016 local i 1042 _iconins ${FUNCNAME} "$@"
1017 local j 1043}
1044
1045# @FUNCTION: newicon
1046# @USAGE: [options] <icon> <newname>
1047# @DESCRIPTION:
1048# Like doicon, install the specified icon as newname.
1049#
1050# @CODE
1051# example 1: newicon foobar.png NEWNAME.png
1018 insinto /usr/share/pixmaps 1052# results in: insinto /usr/share/pixmaps
1019 for i in ${@} 1053# newins foobar.png NEWNAME.png
1020 do
1021 if [ -f "${i}" ];
1022 then
1023 doins ${i}
1024 elif [ -d "${i}" ];
1025 then
1026 for j in ${i}/*.png
1027 do
1028 doins ${j}
1029 done
1030 fi
1031 done
1032}
1033
1034##############################################################
1035# END: Handle .desktop files and menu entries #
1036##############################################################
1037
1038
1039# for internal use only (unpack_pdv and unpack_makeself)
1040find_unpackable_file() {
1041 local src="$1"
1042 if [ -z "${src}" ]
1043 then
1044 src="${DISTDIR}/${A}"
1045 else
1046 if [ -e "${DISTDIR}/${src}" ]
1047 then
1048 src="${DISTDIR}/${src}"
1049 elif [ -e "${PWD}/${src}" ]
1050 then
1051 src="${PWD}/${src}"
1052 elif [ -e "${src}" ]
1053 then
1054 src="${src}"
1055 fi
1056 fi
1057 [ ! -e "${src}" ] && die "Could not find requested archive ${src}"
1058 echo "${src}"
1059}
1060
1061# Unpack those pesky pdv generated files ...
1062# They're self-unpacking programs with the binary package stuffed in
1063# the middle of the archive. Valve seems to use it a lot ... too bad
1064# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1065# 1054#
1066# Usage: unpack_pdv [file to unpack] [size of off_t] 1055# example 2: newicon -s 48 foobar.png NEWNAME.png
1067# - you have to specify the off_t size ... i have no idea how to extract that 1056# results in: insinto /usr/share/icons/hicolor/48x48/apps
1068# information out of the binary executable myself. basically you pass in 1057# newins foobar.png NEWNAME.png
1069# the size of the off_t type (in bytes) on the machine that built the pdv 1058# @CODE
1070# archive. one way to determine this is by running the following commands: 1059newicon() {
1071# strings <pdv archive> | grep lseek 1060 _iconins ${FUNCNAME} "$@"
1072# strace -elseek <pdv archive>
1073# basically look for the first lseek command (we do the strings/grep because
1074# sometimes the function call is _llseek or something) and steal the 2nd
1075# parameter. here is an example:
1076# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1077# lseek
1078# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1079# lseek(3, -4, SEEK_END) = 2981250
1080# thus we would pass in the value of '4' as the second parameter.
1081unpack_pdv() {
1082 local src="`find_unpackable_file $1`"
1083 local sizeoff_t="$2"
1084
1085 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
1086
1087 local shrtsrc="`basename ${src}`"
1088 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1089 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1090 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1091
1092 # grab metadata for debug reasons
1093 local metafile="$(emktemp)"
1094 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1095
1096 # rip out the final file name from the metadata
1097 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1098 datafile="`basename ${datafile}`"
1099
1100 # now lets uncompress/untar the file if need be
1101 local tmpfile="$(emktemp)"
1102 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1103
1104 local iscompressed="`file -b ${tmpfile}`"
1105 if [ "${iscompressed:0:8}" == "compress" ] ; then
1106 iscompressed=1
1107 mv ${tmpfile}{,.Z}
1108 gunzip ${tmpfile}
1109 else
1110 iscompressed=0
1111 fi
1112 local istar="`file -b ${tmpfile}`"
1113 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1114 istar=1
1115 else
1116 istar=0
1117 fi
1118
1119 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1120 #dd if=${src} ibs=${metaskip} count=1 \
1121 # | dd ibs=${tailskip} skip=1 \
1122 # | gzip -dc \
1123 # > ${datafile}
1124 if [ ${iscompressed} -eq 1 ] ; then
1125 if [ ${istar} -eq 1 ] ; then
1126 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1127 | head -c $((${metaskip}-${tailskip})) \
1128 | tar -xzf -
1129 else
1130 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1131 | head -c $((${metaskip}-${tailskip})) \
1132 | gzip -dc \
1133 > ${datafile}
1134 fi
1135 else
1136 if [ ${istar} -eq 1 ] ; then
1137 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1138 | head -c $((${metaskip}-${tailskip})) \
1139 | tar --no-same-owner -xf -
1140 else
1141 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1142 | head -c $((${metaskip}-${tailskip})) \
1143 > ${datafile}
1144 fi
1145 fi
1146 true
1147 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1148 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1149} 1061}
1150 1062
1151# Unpack those pesky makeself generated files ... 1063# @FUNCTION: strip-linguas
1152# They're shell scripts with the binary package tagged onto 1064# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1153# the end of the archive. Loki utilized the format as does 1065# @DESCRIPTION:
1154# many other game companies.
1155#
1156# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1157# - If the file is not specified then unpack will utilize ${A}.
1158# - If the offset is not specified then we will attempt to extract
1159# the proper offset from the script itself.
1160unpack_makeself() {
1161 local src="$(find_unpackable_file "$1")"
1162 local skip="$2"
1163 local exe="$3"
1164
1165 local shrtsrc="$(basename "${src}")"
1166 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1167 if [ -z "${skip}" ]
1168 then
1169 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
1170 local skip=0
1171 exe=tail
1172 case ${ver} in
1173 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1174 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1175 ;;
1176 2.0|2.0.1)
1177 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1178 ;;
1179 2.1.1)
1180 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1181 let skip="skip + 1"
1182 ;;
1183 2.1.2)
1184 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1185 let skip="skip + 1"
1186 ;;
1187 2.1.3)
1188 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1189 let skip="skip + 1"
1190 ;;
1191 2.1.4)
1192 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1193 skip=$(head -n ${skip} "${src}" | wc -c)
1194 exe="dd"
1195 ;;
1196 *)
1197 eerror "I'm sorry, but I was unable to support the Makeself file."
1198 eerror "The version I detected was '${ver}'."
1199 eerror "Please file a bug about the file ${shrtsrc} at"
1200 eerror "http://bugs.gentoo.org/ so that support can be added."
1201 die "makeself version '${ver}' not supported"
1202 ;;
1203 esac
1204 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1205 fi
1206 case ${exe} in
1207 tail) exe="tail -n +${skip} '${src}'";;
1208 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1209 *) die "makeself cant handle exe '${exe}'"
1210 esac
1211
1212 # lets grab the first few bytes of the file to figure out what kind of archive it is
1213 local tmpfile="$(emktemp)"
1214 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1215 local filetype="$(file -b "${tmpfile}")"
1216 case ${filetype} in
1217 *tar\ archive)
1218 eval ${exe} | tar --no-same-owner -xf -
1219 ;;
1220 bzip2*)
1221 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1222 ;;
1223 gzip*)
1224 eval ${exe} | tar --no-same-owner -xzf -
1225 ;;
1226 compress*)
1227 eval ${exe} | gunzip | tar --no-same-owner -xf -
1228 ;;
1229 *)
1230 eerror "Unknown filetype \"${filetype}\" ?"
1231 false
1232 ;;
1233 esac
1234 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1235}
1236
1237# Display a license for user to accept.
1238#
1239# Usage: check_license [license]
1240# - If the file is not specified then ${LICENSE} is used.
1241check_license() {
1242 local lic=$1
1243 if [ -z "${lic}" ] ; then
1244 lic="${PORTDIR}/licenses/${LICENSE}"
1245 else
1246 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
1247 lic="${PORTDIR}/licenses/${src}"
1248 elif [ -e "${PWD}/${src}" ] ; then
1249 lic="${PWD}/${src}"
1250 elif [ -e "${src}" ] ; then
1251 lic="${src}"
1252 fi
1253 fi
1254 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
1255 local l="`basename ${lic}`"
1256
1257 # here is where we check for the licenses the user already
1258 # accepted ... if we don't find a match, we make the user accept
1259 local shopts=$-
1260 local alic
1261 set -o noglob #so that bash doesn't expand "*"
1262 for alic in ${ACCEPT_LICENSE} ; do
1263 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1264 set +o noglob; set -${shopts} #reset old shell opts
1265 return 0
1266 fi
1267 done
1268 set +o noglob; set -$shopts #reset old shell opts
1269
1270 local licmsg="$(emktemp)"
1271 cat << EOF > ${licmsg}
1272**********************************************************
1273The following license outlines the terms of use of this
1274package. You MUST accept this license for installation to
1275continue. When you are done viewing, hit 'q'. If you
1276CTRL+C out of this, the install will not run!
1277**********************************************************
1278
1279EOF
1280 cat ${lic} >> ${licmsg}
1281 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1282 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1283 read alic
1284 case ${alic} in
1285 yes|Yes|y|Y)
1286 return 0
1287 ;;
1288 *)
1289 echo;echo;echo
1290 eerror "You MUST accept the license to continue! Exiting!"
1291 die "Failed to accept license"
1292 ;;
1293 esac
1294}
1295
1296# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1297# the whole 'non-interactive' policy, but damnit I want CD support !
1298#
1299# with these cdrom functions we handle all the user interaction and
1300# standardize everything. all you have to do is call cdrom_get_cds()
1301# and when the function returns, you can assume that the cd has been
1302# found at CDROM_ROOT.
1303#
1304# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1305# etc... if you want to give the cds better names, then just export
1306# the CDROM_NAME_X variables before calling cdrom_get_cds().
1307#
1308# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1309#
1310# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1311# - this will attempt to locate a cd based upon a file that is on
1312# the cd ... the more files you give this function, the more cds
1313# the cdrom functions will handle
1314cdrom_get_cds() {
1315 # first we figure out how many cds we're dealing with by
1316 # the # of files they gave us
1317 local cdcnt=0
1318 local f=
1319 for f in "$@" ; do
1320 cdcnt=$((cdcnt + 1))
1321 export CDROM_CHECK_${cdcnt}="$f"
1322 done
1323 export CDROM_TOTAL_CDS=${cdcnt}
1324 export CDROM_CURRENT_CD=1
1325
1326 # now we see if the user gave use CD_ROOT ...
1327 # if they did, let's just believe them that it's correct
1328 if [[ ! -z ${CD_ROOT} ]] ; then
1329 export CDROM_ROOT=${CD_ROOT}
1330 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1331 return
1332 fi
1333 # do the same for CD_ROOT_X
1334 if [[ ! -z ${CD_ROOT_1} ]] ; then
1335 local var=
1336 cdcnt=0
1337 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1338 cdcnt=$((cdcnt + 1))
1339 var="CD_ROOT_${cdcnt}"
1340 if [[ -z ${!var} ]] ; then
1341 eerror "You must either use just the CD_ROOT"
1342 eerror "or specify ALL the CD_ROOT_X variables."
1343 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1344 die "could not locate CD_ROOT_${cdcnt}"
1345 fi
1346 export CDROM_ROOTS_${cdcnt}="${!var}"
1347 done
1348 export CDROM_ROOT=${CDROM_ROOTS_1}
1349 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1350 return
1351 fi
1352
1353 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1354 einfon "This ebuild will need the "
1355 if [[ -z ${CDROM_NAME} ]] ; then
1356 echo "cdrom for ${PN}."
1357 else
1358 echo "${CDROM_NAME}."
1359 fi
1360 echo
1361 einfo "If you do not have the CD, but have the data files"
1362 einfo "mounted somewhere on your filesystem, just export"
1363 einfo "the variable CD_ROOT so that it points to the"
1364 einfo "directory containing the files."
1365 echo
1366 einfo "For example:"
1367 einfo "export CD_ROOT=/mnt/cdrom"
1368 echo
1369 else
1370 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1371 cdcnt=0
1372 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1373 cdcnt=$((cdcnt + 1))
1374 var="CDROM_NAME_${cdcnt}"
1375 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1376 done
1377 echo
1378 einfo "If you do not have the CDs, but have the data files"
1379 einfo "mounted somewhere on your filesystem, just export"
1380 einfo "the following variables so they point to the right place:"
1381 einfon ""
1382 cdcnt=0
1383 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1384 cdcnt=$((cdcnt + 1))
1385 echo -n " CD_ROOT_${cdcnt}"
1386 done
1387 echo
1388 einfo "Or, if you have all the files in the same place, or"
1389 einfo "you only have one cdrom, you can export CD_ROOT"
1390 einfo "and that place will be used as the same data source"
1391 einfo "for all the CDs."
1392 echo
1393 einfo "For example:"
1394 einfo "export CD_ROOT_1=/mnt/cdrom"
1395 echo
1396 fi
1397 export CDROM_CURRENT_CD=0
1398 cdrom_load_next_cd
1399}
1400
1401# this is only used when you need access to more than one cd.
1402# when you have finished using the first cd, just call this function.
1403# when it returns, CDROM_ROOT will be pointing to the second cd.
1404# remember, you can only go forward in the cd chain, you can't go back.
1405cdrom_load_next_cd() {
1406 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1407 local var=
1408
1409 if [[ ! -z ${CD_ROOT} ]] ; then
1410 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1411 return
1412 fi
1413
1414 unset CDROM_ROOT
1415 var=CDROM_ROOTS_${CDROM_CURRENT_CD}
1416 if [[ -z ${!var} ]] ; then
1417 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1418 cdrom_locate_file_on_cd ${!var}
1419 else
1420 export CDROM_ROOT=${!var}
1421 fi
1422
1423 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1424}
1425
1426# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1427# functions. this should *never* be called from an ebuild.
1428# all it does is try to locate a give file on a cd ... if the cd isn't
1429# found, then a message asking for the user to insert the cdrom will be
1430# displayed and we'll hang out here until:
1431# (1) the file is found on a mounted cdrom
1432# (2) the user hits CTRL+C
1433cdrom_locate_file_on_cd() {
1434 while [[ -z ${CDROM_ROOT} ]] ; do
1435 local dir="$(dirname ${@})"
1436 local file="$(basename ${@})"
1437 local mline=""
1438 local showedmsg=0
1439
1440 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do
1441 [[ -d ${mline}/${dir} ]] || continue
1442 [[ ! -z $(find ${mline}/${dir} -iname ${file} -maxdepth 1) ]] \
1443 && export CDROM_ROOT=${mline}
1444 done
1445
1446 if [[ -z ${CDROM_ROOT} ]] ; then
1447 echo
1448 if [[ ${showedmsg} -eq 0 ]] ; then
1449 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1450 if [[ -z ${CDROM_NAME} ]] ; then
1451 einfo "Please insert the cdrom for ${PN} now !"
1452 else
1453 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1454 fi
1455 else
1456 if [[ -z ${CDROM_NAME_1} ]] ; then
1457 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1458 else
1459 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1460 einfo "Please insert+mount the ${!var} cdrom now !"
1461 fi
1462 fi
1463 showedmsg=1
1464 fi
1465 einfo "Press return to scan for the cd again"
1466 einfo "or hit CTRL+C to abort the emerge."
1467 read
1468 fi
1469 done
1470}
1471
1472# Make sure that LINGUAS only contains languages that 1066# Make sure that LINGUAS only contains languages that
1473# a package can support 1067# a package can support. The first form allows you to
1474# 1068# specify a list of LINGUAS. The -i builds a list of po
1475# usage: strip-linguas <allow LINGUAS> 1069# files found in all the directories and uses the
1476# strip-linguas -i <directories of .po files> 1070# intersection of the lists. The -u builds a list of po
1477# strip-linguas -u <directories of .po files> 1071# files found in all the directories and uses the union
1478# 1072# of the lists.
1479# The first form allows you to specify a list of LINGUAS.
1480# The -i builds a list of po files found in all the
1481# directories and uses the intersection of the lists.
1482# The -u builds a list of po files found in all the
1483# directories and uses the union of the lists.
1484strip-linguas() { 1073strip-linguas() {
1485 local ls newls 1074 local ls newls nols
1486 if [ "$1" == "-i" ] || [ "$1" == "-u" ] ; then 1075 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1487 local op="$1"; shift 1076 local op=$1; shift
1488 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1077 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1489 local d f 1078 local d f
1490 for d in "$@" ; do 1079 for d in "$@" ; do
1491 if [ "${op}" == "-u" ] ; then 1080 if [[ ${op} == "-u" ]] ; then
1492 newls="${ls}" 1081 newls=${ls}
1493 else 1082 else
1494 newls="" 1083 newls=""
1495 fi 1084 fi
1496 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1085 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1497 if [ "${op}" == "-i" ] ; then 1086 if [[ ${op} == "-i" ]] ; then
1498 [ "${ls/ ${f} /}" != "${ls}" ] && newls="${newls} ${f}" 1087 has ${f} ${ls} && newls="${newls} ${f}"
1499 else 1088 else
1500 [ "${ls/ ${f} /}" == "${ls}" ] && newls="${newls} ${f}" 1089 has ${f} ${ls} || newls="${newls} ${f}"
1501 fi 1090 fi
1502 done 1091 done
1503 ls="${newls}" 1092 ls=${newls}
1504 done 1093 done
1505 ls="${ls//.po}"
1506 else 1094 else
1507 ls="$@" 1095 ls="$@"
1508 fi 1096 fi
1509 1097
1510 ls=" ${ls} " 1098 nols=""
1511 newls="" 1099 newls=""
1512 for f in ${LINGUAS} ; do 1100 for f in ${LINGUAS} ; do
1513 if [ "${ls/ ${f} /}" != "${ls}" ] ; then 1101 if has ${f} ${ls} ; then
1514 newls="${newls} ${f}" 1102 newls="${newls} ${f}"
1515 else 1103 else
1516 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1104 nols="${nols} ${f}"
1517 fi 1105 fi
1518 done 1106 done
1519 if [ -z "${newls}" ] ; then 1107 [[ -n ${nols} ]] \
1520 unset LINGUAS 1108 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1521 else
1522 export LINGUAS="${newls}" 1109 export LINGUAS=${newls:1}
1523 fi
1524} 1110}
1525 1111
1526# moved from kernel.eclass since they are generally useful outside of 1112# @FUNCTION: preserve_old_lib
1527# kernel.eclass -iggy (20041002) 1113# @USAGE: <libs to preserve> [more libs]
1528 1114# @DESCRIPTION:
1529# the following functions are useful in kernel module ebuilds, etc.
1530# for an example see ivtv or drbd ebuilds
1531
1532# set's ARCH to match what the kernel expects
1533set_arch_to_kernel() {
1534 i=10
1535 while ((i--)) ; do
1536 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1537 done
1538 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1539 case ${ARCH} in
1540 x86) export ARCH="i386";;
1541 amd64) export ARCH="x86_64";;
1542 hppa) export ARCH="parisc";;
1543 mips) export ARCH="mips";;
1544 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1545 *) export ARCH="${ARCH}";;
1546 esac
1547}
1548
1549# set's ARCH back to what portage expects
1550set_arch_to_portage() {
1551 i=10
1552 while ((i--)) ; do
1553 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1554 done
1555 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1556}
1557
1558# Jeremy Huddleston <eradicator@gentoo.org>:
1559# preserve_old_lib /path/to/libblah.so.0
1560# preserve_old_lib_notify /path/to/libblah.so.0
1561#
1562# These functions are useful when a lib in your package changes --soname. Such 1115# These functions are useful when a lib in your package changes ABI SONAME.
1563# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1116# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1564# would break packages that link against it. Most people get around this 1117# would break packages that link against it. Most people get around this
1565# by using the portage SLOT mechanism, but that is not always a relevant 1118# by using the portage SLOT mechanism, but that is not always a relevant
1566# solution, so instead you can add the following to your ebuilds: 1119# solution, so instead you can call this from pkg_preinst. See also the
1567# 1120# preserve_old_lib_notify function.
1568# src_install() {
1569# ...
1570# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1571# ...
1572# }
1573#
1574# pkg_postinst() {
1575# ...
1576# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1577# ...
1578# }
1579
1580preserve_old_lib() { 1121preserve_old_lib() {
1581 LIB=$1 1122 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1123 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1124 die "Invalid preserve_old_lib() usage"
1125 fi
1126 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1582 1127
1583 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1128 # let portage worry about it
1584 SONAME=`basename ${LIB}` 1129 has preserve-libs ${FEATURES} && return 0
1585 DIRNAME=`dirname ${LIB}`
1586 1130
1587 dodir ${DIRNAME} 1131 local lib dir
1588 cp ${ROOT}${LIB} ${D}${DIRNAME} 1132 for lib in "$@" ; do
1133 [[ -e ${ROOT}/${lib} ]] || continue
1134 dir=${lib%/*}
1135 dodir ${dir} || die "dodir ${dir} failed"
1136 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1589 touch ${D}${LIB} 1137 touch "${D}"/${lib}
1590 fi 1138 done
1591} 1139}
1592 1140
1141# @FUNCTION: preserve_old_lib_notify
1142# @USAGE: <libs to notify> [more libs]
1143# @DESCRIPTION:
1144# Spit helpful messages about the libraries preserved by preserve_old_lib.
1593preserve_old_lib_notify() { 1145preserve_old_lib_notify() {
1594 LIB=$1 1146 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1147 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1148 die "Invalid preserve_old_lib_notify() usage"
1149 fi
1595 1150
1596 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1151 # let portage worry about it
1597 SONAME=`basename ${LIB}` 1152 has preserve-libs ${FEATURES} && return 0
1598 1153
1154 local lib notice=0
1155 for lib in "$@" ; do
1156 [[ -e ${ROOT}/${lib} ]] || continue
1157 if [[ ${notice} -eq 0 ]] ; then
1158 notice=1
1599 einfo "An old version of an installed library was detected on your system." 1159 ewarn "Old versions of installed libraries were detected on your system."
1600 einfo "In order to avoid breaking packages that link against is, this older version" 1160 ewarn "In order to avoid breaking packages that depend on these old libs,"
1601 einfo "is not being removed. In order to make full use of this newer version," 1161 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1602 einfo "you will need to execute the following command:" 1162 ewarn "in order to remove these old dependencies. If you do not have this"
1603 einfo " revdep-rebuild --soname ${SONAME}" 1163 ewarn "helper program, simply emerge the 'gentoolkit' package."
1604 einfo 1164 ewarn
1605 einfo "After doing that, you can safely remove ${LIB}"
1606 einfo "Note: 'emerge gentoolkit' to get revdep-rebuild"
1607 fi 1165 fi
1166 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1167 done
1608} 1168}
1609 1169
1610# Hack for people to figure out if a package was built with 1170# @FUNCTION: built_with_use
1611# certain USE flags 1171# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1172# @DESCRIPTION:
1612# 1173#
1613# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1174# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1614# ex: built_with_use xchat gtk2
1615# 1175#
1616# Flags: -a all USE flags should be utilized 1176# A temporary hack until portage properly supports DEPENDing on USE
1617# -o at least one USE flag should be utilized 1177# flags being enabled in packages. This will check to see if the specified
1618# Note: the default flag is '-a' 1178# DEPEND atom was built with the specified list of USE flags. The
1179# --missing option controls the behavior if called on a package that does
1180# not actually support the defined USE flags (aka listed in IUSE).
1181# The default is to abort (call die). The -a and -o flags control
1182# the requirements of the USE flags. They correspond to "and" and "or"
1183# logic. So the -a flag means all listed USE flags must be enabled
1184# while the -o flag means at least one of the listed IUSE flags must be
1185# enabled. The --hidden option is really for internal use only as it
1186# means the USE flag we're checking is hidden expanded, so it won't be found
1187# in IUSE like normal USE flags.
1188#
1189# Remember that this function isn't terribly intelligent so order of optional
1190# flags matter.
1619built_with_use() { 1191built_with_use() {
1192 local hidden="no"
1193 if [[ $1 == "--hidden" ]] ; then
1194 hidden="yes"
1195 shift
1196 fi
1197
1198 local missing_action="die"
1199 if [[ $1 == "--missing" ]] ; then
1200 missing_action=$2
1201 shift ; shift
1202 case ${missing_action} in
1203 true|false|die) ;;
1204 *) die "unknown action '${missing_action}'";;
1205 esac
1206 fi
1207
1620 local opt=$1 1208 local opt=$1
1621 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1209 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1622 1210
1623 local PKG=$(best_version $1) 1211 local PKG=$(best_version $1)
1212 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1624 shift 1213 shift
1625 1214
1626 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1215 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1627 [[ ! -e ${USEFILE} ]] && return 1 1216 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1217
1218 # if the IUSE file doesn't exist, the read will error out, we need to handle
1219 # this gracefully
1220 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1221 case ${missing_action} in
1222 true) return 0;;
1223 false) return 1;;
1224 die) die "Unable to determine what USE flags $PKG was built with";;
1225 esac
1226 fi
1227
1228 if [[ ${hidden} == "no" ]] ; then
1229 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1230 # Don't check USE_EXPAND #147237
1231 local expand
1232 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1233 if [[ $1 == ${expand}_* ]] ; then
1234 expand=""
1235 break
1236 fi
1237 done
1238 if [[ -n ${expand} ]] ; then
1239 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1240 case ${missing_action} in
1241 true) return 0;;
1242 false) return 1;;
1243 die) die "$PKG does not actually support the $1 USE flag!";;
1244 esac
1245 fi
1246 fi
1247 fi
1628 1248
1629 local USE_BUILT=$(<${USEFILE}) 1249 local USE_BUILT=$(<${USEFILE})
1630 while [[ $# -gt 0 ]] ; do 1250 while [[ $# -gt 0 ]] ; do
1631 if [[ ${opt} = "-o" ]] ; then 1251 if [[ ${opt} = "-o" ]] ; then
1632 has $1 ${USE_BUILT} && return 0 1252 has $1 ${USE_BUILT} && return 0
1636 shift 1256 shift
1637 done 1257 done
1638 [[ ${opt} = "-a" ]] 1258 [[ ${opt} = "-a" ]]
1639} 1259}
1640 1260
1261# @FUNCTION: epunt_cxx
1262# @USAGE: [dir to scan]
1263# @DESCRIPTION:
1641# Many configure scripts wrongly bail when a C++ compiler 1264# Many configure scripts wrongly bail when a C++ compiler could not be
1642# could not be detected. #73450 1265# detected. If dir is not specified, then it defaults to ${S}.
1266#
1267# http://bugs.gentoo.org/73450
1643epunt_cxx() { 1268epunt_cxx() {
1644 local dir=$1 1269 local dir=$1
1645 [[ -z ${dir} ]] && dir=${S} 1270 [[ -z ${dir} ]] && dir=${S}
1646 ebegin "Removing useless C++ checks" 1271 ebegin "Removing useless C++ checks"
1647 local f 1272 local f
1648 for f in $(find ${dir} -name configure) ; do 1273 find "${dir}" -name configure | while read f ; do
1649 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1274 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1650 done 1275 done
1651 eend 0 1276 eend 0
1652} 1277}
1653 1278
1654# dopamd <file> [more files] 1279# @FUNCTION: make_wrapper
1655# 1280# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1656# Install pam auth config file in /etc/pam.d 1281# @DESCRIPTION:
1657dopamd() { 1282# Create a shell wrapper script named wrapper in installpath
1658 [[ -z $1 ]] && die "dopamd requires at least one argument" 1283# (defaults to the bindir) to execute target (default of wrapper) by
1659 1284# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1660 use pam || return 0 1285# libpaths followed by optionally changing directory to chdir.
1661 1286make_wrapper() {
1662 insinto /etc/pam.d 1287 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1663 # these are the default doins options, but be explicit just in case 1288 local tmpwrapper=$(emktemp)
1664 insopts -m 0644 -o root -g root 1289 # We don't want to quote ${bin} so that people can pass complex
1665 doins "$@" || die "failed to install $@" 1290 # things as $bin ... "./someprog --args"
1291 cat << EOF > "${tmpwrapper}"
1292#!/bin/sh
1293cd "${chdir:-.}"
1294if [ -n "${libdir}" ] ; then
1295 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1296 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1297 else
1298 export LD_LIBRARY_PATH="${libdir}"
1299 fi
1300fi
1301exec ${bin} "\$@"
1302EOF
1303 chmod go+rx "${tmpwrapper}"
1304 if [[ -n ${path} ]] ; then
1305 (
1306 exeinto "${path}"
1307 newexe "${tmpwrapper}" "${wrapper}"
1308 ) || die
1309 else
1310 newbin "${tmpwrapper}" "${wrapper}" || die
1311 fi
1666} 1312}
1667# newpamd <old name> <new name>
1668#
1669# Install pam file <old name> as <new name> in /etc/pam.d
1670newpamd() {
1671 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1672 1313
1673 use pam || return 0 1314# @FUNCTION: path_exists
1315# @USAGE: [-a|-o] <paths>
1316# @DESCRIPTION:
1317# Check if the specified paths exist. Works for all types of paths
1318# (files/dirs/etc...). The -a and -o flags control the requirements
1319# of the paths. They correspond to "and" and "or" logic. So the -a
1320# flag means all the paths must exist while the -o flag means at least
1321# one of the paths must exist. The default behavior is "and". If no
1322# paths are specified, then the return value is "false".
1323path_exists() {
1324 local opt=$1
1325 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1674 1326
1675 insinto /etc/pam.d 1327 # no paths -> return false
1676 # these are the default doins options, but be explicit just in case 1328 # same behavior as: [[ -e "" ]]
1677 insopts -m 0644 -o root -g root 1329 [[ $# -eq 0 ]] && return 1
1678 newins "$1" "$2" || die "failed to install $1 as $2" 1330
1331 local p r=0
1332 for p in "$@" ; do
1333 [[ -e ${p} ]]
1334 : $(( r += $? ))
1335 done
1336
1337 case ${opt} in
1338 -a) return $(( r != 0 )) ;;
1339 -o) return $(( r == $# )) ;;
1340 esac
1679} 1341}
1342
1343# @FUNCTION: in_iuse
1344# @USAGE: <flag>
1345# @DESCRIPTION:
1346# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1347# as necessary.
1348#
1349# Note that this function should not be used in the global scope.
1350in_iuse() {
1351 debug-print-function ${FUNCNAME} "${@}"
1352 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1353
1354 local flag=${1}
1355 local liuse=( ${IUSE} )
1356
1357 has "${flag}" "${liuse[@]#[+-]}"
1358}
1359
1360# @FUNCTION: use_if_iuse
1361# @USAGE: <flag>
1362# @DESCRIPTION:
1363# Return true if the given flag is in USE and IUSE.
1364#
1365# Note that this function should not be used in the global scope.
1366use_if_iuse() {
1367 in_iuse $1 || return 1
1368 use $1
1369}
1370
1371# @FUNCTION: usex
1372# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1373# @DESCRIPTION:
1374# Proxy to declare usex for package managers or EAPIs that do not provide it
1375# and use the package manager implementation when available (i.e. EAPI >= 5).
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378if has "${EAPI:-0}" 0 1 2 3 4; then
1379 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1380fi
1381
1382# @FUNCTION: prune_libtool_files
1383# @USAGE: [--all]
1384# @DESCRIPTION:
1385# Locate unnecessary libtool files (.la) and libtool static archives
1386# (.a) and remove them from installation image.
1387#
1388# By default, .la files are removed whenever the static linkage can
1389# either be performed using pkg-config or doesn't introduce additional
1390# flags.
1391#
1392# If '--all' argument is passed, all .la files are removed. This is
1393# usually useful when the package installs plugins and does not use .la
1394# files for loading them.
1395#
1396# The .a files are only removed whenever corresponding .la files state
1397# that they should not be linked to, i.e. whenever these files
1398# correspond to plugins.
1399#
1400# Note: if your package installs both static libraries and .pc files,
1401# you need to add pkg-config to your DEPEND.
1402prune_libtool_files() {
1403 debug-print-function ${FUNCNAME} "$@"
1404
1405 local removing_all opt
1406 for opt; do
1407 case "${opt}" in
1408 --all)
1409 removing_all=1
1410 ;;
1411 *)
1412 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1413 esac
1414 done
1415
1416 local f
1417 local queue=()
1418 while IFS= read -r -d '' f; do # for all .la files
1419 local archivefile=${f/%.la/.a}
1420
1421 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1422
1423 # Remove static libs we're not supposed to link against.
1424 if grep -q '^shouldnotlink=yes$' "${f}"; then
1425 if [[ -f ${archivefile} ]]; then
1426 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1427 queue+=( "${archivefile}" )
1428 fi
1429
1430 # The .la file may be used by a module loader, so avoid removing it
1431 # unless explicitly requested.
1432 [[ ${removing_all} ]] || continue
1433 fi
1434
1435 # Remove .la files when:
1436 # - user explicitly wants us to remove all .la files,
1437 # - respective static archive doesn't exist,
1438 # - they are covered by a .pc file already,
1439 # - they don't provide any new information (no libs & no flags).
1440 local reason pkgconfig_scanned
1441 if [[ ${removing_all} ]]; then
1442 reason='requested'
1443 elif [[ ! -f ${archivefile} ]]; then
1444 reason='no static archive'
1445 elif [[ ! $(sed -nre \
1446 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1447 "${f}") ]]; then
1448 reason='no libs & flags'
1449 else
1450 if [[ ! ${pkgconfig_scanned} ]]; then
1451 # Create a list of all .pc-covered libs.
1452 local pc_libs=()
1453 if [[ ! ${removing_all} ]]; then
1454 local f
1455 local tf=${T}/prune-lt-files.pc
1456 local pkgconf=$(tc-getPKG_CONFIG)
1457
1458 while IFS= read -r -d '' f; do # for all .pc files
1459 local arg
1460
1461 sed -e '/^Requires:/d' "${f}" > "${tf}"
1462 for arg in $("${pkgconf}" --libs "${tf}"); do
1463 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1464 done
1465 done < <(find "${D}" -type f -name '*.pc' -print0)
1466
1467 rm -f "${tf}"
1468 fi
1469
1470 pkgconfig_scanned=1
1471 fi
1472
1473 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1474 fi
1475
1476 if [[ ${reason} ]]; then
1477 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1478 queue+=( "${f}" )
1479 fi
1480 done < <(find "${D}" -xtype f -name '*.la' -print0)
1481
1482 if [[ ${queue[@]} ]]; then
1483 rm -f "${queue[@]}"
1484 fi
1485}
1486
1487check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1488
1489fi

Legend:
Removed from v.1.152  
changed lines
  Added in v.1.407

  ViewVC Help
Powered by ViewVC 1.1.20